//Originally Balloon Park Bumpers by Sal
//Modified for High Top Bumpers

freeslot("MT_HIGHTOP_BUMPER", "S_HIGHTOP_BUMPER", "S_HIGHTOP_BUMPERHIT", "SPR_HTBP")

mobjinfo[MT_HIGHTOP_BUMPER] = {
	//$Sprite HTBPA0
	//$Name Balloon Park Bumper
	spawnstate = S_HIGHTOP_BUMPER,
	seestate = S_HIGHTOP_BUMPERHIT,
	radius = 24*FRACUNIT,
	height = 32*FRACUNIT,
	doomednum = 461,
	dispoffset = 0,
	deathstate = S_NULL,
	deathsound = sfx_s3kaa,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

states[S_HIGHTOP_BUMPER] = {SPR_HTBP, FF_SEMIBRIGHT|A, -1, nil, 0, 0, S_HIGHTOP_BUMPER}
states[S_HIGHTOP_BUMPERHIT] = {SPR_HTBP, FF_FULLBRIGHT|B, 2, nil, 0, 0, S_HIGHTOP_BUMPER}

local BUMPER_STRENGTH = 42

addHook("TouchSpecial", function(bumper, pmo)
	local hang = R_PointToAngle2(
		bumper.x, bumper.y,
		pmo.x, pmo.y
	)
	local vang = 0

	if (P_IsObjectOnGround(pmo) == false)
		vang = R_PointToAngle2(
			FixedHypot(bumper.x, bumper.y), bumper.z + (bumper.height >> 1),
			FixedHypot(pmo.x, pmo.y), pmo.z + (pmo.height >> 1)
		)
	end

	local str = (BUMPER_STRENGTH * bumper.scale) >> 1

	pmo.momx = FixedMul(FixedMul(str, cos(hang)), abs(cos(vang)))
	pmo.momy = FixedMul(FixedMul(str, sin(hang)), abs(cos(vang)))
	pmo.momz = FixedMul(str, sin(vang))

	if (pmo.player and pmo.player.valid)
		if (pmo.player.tiregrease == 0)
			for i = 0,1 do
				local grease = P_SpawnMobjFromMobj(pmo, 0, 0, 0, MT_TIREGREASE)
				grease.target = pmo
				grease.angle = pmo.angle
				grease.extravalue1 = i
			end
		end

		if (pmo.player.tiregrease < 2*TICRATE) // greasetics
			pmo.player.tiregrease = 2*TICRATE
		end
	end

	if (bumper.state != bumper.info.seestate)
		S_StartSound(bumper, bumper.info.deathsound)
		bumper.state = bumper.info.seestate
	end

	return true
end, MT_HIGHTOP_BUMPER)

addHook("MobjSpawn", function(bumper)
	bumper.shadowscale = FRACUNIT
	bumper.destscale = $1 << 1
	P_SetScale(bumper, bumper.destscale)
end, MT_HIGHTOP_BUMPER)
