-- ULTRAKILL-style boss health bars
-- Designed to be stacked...

local g_healthBars = {}
addHook("NetVars", function(net)
	g_healthBars = net($)
end)

local clr = {
	SKINCOLOR_KETCHUP,
	SKINCOLOR_BLOSSOM,
	SKINCOLOR_MAGENTA,
	SKINCOLOR_PURPLE,
}

-- Why isn't this exposed?
local function L_TimeFrac(tics, duration)
	return tics < duration and (tics * FRACUNIT) / duration or FRACUNIT
end
local M_TimeFrac = M_TimeFrac or L_TimeFrac -- M_TimeFrac may be exposed in the future idk

local function addHealthBar(mo, maxHealth, subdivisions, name)
	subdivisions = $ or 1
	if subdivisions > 4 then error("PPZ_InitHealthBar: subdivisions cannot be bigger than 4!") end
	
	local hb = {}
	hb.barval = maxHealth/subdivisions
	hb.maxval = maxHealth
	hb.subdivisions = subdivisions
	hb.current = 0 -- to gradually refill on start
	hb.currentdur = 0
	hb.track = mo
	hb.name = name
	hb.lasthealth = maxHealth
	hb.dmgindicator = 0
	hb.dmgindicatordur = 0
	
	table.insert(g_healthBars, hb)
end
rawset(_G, "PPZ_InitHealthBar", addHealthBar)

local function updateHealthBars()
	if #g_healthBars == 0 then return end
	local rm = {}
	for i=1,#g_healthBars do
		local hb = g_healthBars[i]
		if (not (hb.track and hb.track.valid)) or hb.track.hbdeferDie then 
			rm[i] = true
			continue
		end
		-- exponential ease into current health
		if hb.lasthealth != hb.track.health then
			if hb.current != 0 then
				hb.dmgindicator = abs(hb.lasthealth-hb.track.health)*(152/hb.barval)
				hb.dmgindicatordur = TICRATE*3/2
			end
			hb.currentdur = 0
		end
		hb.currentdur = $ + 1
		hb.dmgindicatordur = max(0, $ - 1)
		local fuck = max(FRACUNIT/32, M_TimeFrac(min(TICRATE, hb.currentdur), TICRATE))
		hb.current = ease.linear(fuck, $*FRACUNIT, hb.track.health*FRACUNIT)/FRACUNIT
		hb.lasthealth = hb.track.health
		-- dmg indicator bullshit
		fuck = max(FRACUNIT/32, M_TimeFrac(min(TICRATE, hb.dmgindicatordur), TICRATE))
		hb.dmgindicator = ease.linear(fuck, 0, $*FRACUNIT)/FRACUNIT
		--print(hb.current)
	end
	-- remove if marked as such
	for i=#g_healthBars,1,-1 do
		if rm[i] then
			table.remove(g_healthBars, i)
		end
	end
end
addHook("PostThinkFrame", updateHealthBars)

local BASEVIDWIDTH = 320
local BASEVIDHEIGHT = 200

local function L_DrawVariableBar(v, x, y, w, scr, clr, border, bar)
	border = $ or "K_BOSB04"
	bar = $ or "K_BOSB03"
	-- left border
	v.drawStretched(
		x, y,
		min(FRACUNIT, w), FRACUNIT,
		v.cachePatch(border),
		scr, clr
	)
	-- main bar
	v.drawStretched(
		x+FRACUNIT, y,
		max(0, w-(FRACUNIT*2)), FRACUNIT,
		v.cachePatch(bar),
		scr, clr
	)
	-- right border
	v.drawStretched(
		x+(w-FRACUNIT), y,
		min(FRACUNIT, w), FRACUNIT,
		v.cachePatch(border),
		scr, clr
	)
end

local function hudshit(v, p, c)
	-- THIS is where the meat is
	if #g_healthBars == 0 then return end

	local ti = 0
	for i=#g_healthBars,1,-1 do
		local hb = g_healthBars[i]
		
		local fx = (BASEVIDWIDTH/4)<<FRACBITS
		local fy = (BASEVIDHEIGHT-13-(13*ti))<<FRACBITS
		
		local level = min(5, (hb.current / hb.barval)+1)
		local level2 = max(0, level-1)
		local w = max(0, FixedDiv(((hb.current % hb.barval) * 152*FRACUNIT), hb.barval*FRACUNIT))
		
		-- small bg
		v.drawStretched(fx, fy, (160*FRACUNIT)/64, (11*FRACUNIT)/64, v.cachePatch("~031"), V_SNAPTOBOTTOM|V_TRANSLUCENT)
		if level2 > 0 then
			L_DrawVariableBar(v, fx + (4<<FRACBITS), fy, (152*FRACUNIT), V_SNAPTOBOTTOM, v.getColormap(TC_RAINBOW, clr[level2]))
		end
		if level < 5 then
			L_DrawVariableBar(v, fx + (4<<FRACBITS), fy, w, V_SNAPTOBOTTOM, v.getColormap(TC_RAINBOW, clr[level]))
		end
		-- damage indicator
		L_DrawVariableBar(v, fx + (4<<FRACBITS) + w, fy, min((hb.dmgindicator*FRACUNIT), (152*FRACUNIT)-w), V_SNAPTOBOTTOM, nil, "K_BOSB06", "K_BOSB05")
		-- name
		v.drawString((BASEVIDWIDTH/2), (fy/FRACUNIT)+1, hb.name, V_SNAPTOBOTTOM|V_TRANSLUCENT, "thin-center")
		ti = $+1
	end
end
hud.add(hudshit, "game")